<?php
/**
 * $Horde: nic/graph.php,v 1.14 2004/08/08 02:09:25 chuck Exp $
 *
 * Copyright 2002 Mike Cochrane <mike@graftonhall.co.nz>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

@define('NIC_BASE', dirname(__FILE__));
require_once NIC_BASE . '/lib/base.php';
require_once NIC_BASE . '/lib/Device.php';
require_once NIC_BASE . '/lib/Storage.php';
require_once 'Horde/Graph.php';

// Retrieve the form values.
$requestedid = Util::getFormData('deviceid');
$deviceid = Util::getFormData('device');
$graphID = Util::getFormData('graph');
$start_time = Util::getFormData('start', time() - 12 * 3600);
$end_time = Util::getFormData('end', time());
$step = Util::getFormData('step', 300);

// Get data values.
$dev = &Nic_Device::singleton($devices[$deviceid]['driver'], $devices[$deviceid]['params']);
$storage = &Nic_Storage::singleton();

$thisGraph = $dev->_graphs[$graphID];

$colors[0] = 'orange';
$colors[1] = 'blue';
$colors[2] = 'green';
$colors[3] = 'red';

// Create new graph.
$height = 250 + (50 * count($thisGraph['data']));
$graph = &new Horde_Graph(array('width' => 600, 'height' => $height, 'temp' => Horde::getTempDir()));

// Set Graph Title
$graph->set('title', $thisGraph['title']);

$graph->set('xlabel', _("Time"));
$graph->set('ylabel', $thisGraph['axisLabel']);

$caption = '';
$labels = array();
$i = 0;
foreach ($thisGraph['data'] as $key => $plotdata) {
    $results = $storage->fetch($devices[$deviceid]['params']['hostname'],
                               $devices[$deviceid]['params']['subsystem'], $plotdata['source'], $plotdata['type'], $start_time, $end_time, $step);

    $values = array();
    $labels = array();
    foreach ($results as $label => $value) {
        $labels[] = date('H:i', $label);
        if (isset($plotdata['scaling function']) && !empty($plotdata['scaling function'])) {
            eval('$values[] = ' . str_replace('%value', $value, $plotdata['scaling function']) . ';');
        } else {
            $values[] = $value;
        }
    }

    // Add the line graph.
    $graph->addPlot('line', array('dataset' => $graph->addYData($values),
                                  'color' => $colors[$i++]));

    if (count($thisGraph['data']) > 1) {
        // $plots[$key]->SetLegend($plotdata['legend']);
    } else {
        // $graph->subtitle->Set($plotdata['legend']);
    }

    $caption .= empty($caption) ? '' : "\n\n";
    $caption .= trim($plotdata['legend']) . "\n" . trim($plotdata['description']);
}

// Add $caption.

// $graph->xaxis->SetTextTickInterval(floor(($end_time - $start_time)/3600));
// $graph->xaxis->SetTextLabelInterval(1);
$graph->addXData($labels);

// Output the graph.
$graph->draw();
